/**************************
 * Deloitte
 * Actions implemented for Deloitte
 * By cas220
 **************************/

package models.home_company;

import models.SimpleFirmModel.Messages;
import simudyne.core.abm.Action;

public class MainFirm extends SuperHomeCompany {

  /*******************************
   * Action Implementations:
   *******************************/

  public static Action<MainFirm> registerWithMarket =
      Action.create(MainFirm.class, SuperHomeCompany::registerWithMarketMethod);

  public static Action<MainFirm> registerConsultants =
      Action.create(
          MainFirm.class,
          a -> {
            a.getMessagesOfType(Messages.RegistrationConsultant.class).forEach(a::consultantSetup);
          });

  public static Action<MainFirm> contractReview =
      Action.create(
          MainFirm.class,
          a -> {
            a.getMessagesOfType(Messages.ContractProposal.class).forEach(a::acceptContract);
          });

  public static Action<MainFirm> contractStep =
      Action.create(MainFirm.class, SuperHomeCompany::stepContract);

  public static Action<MainFirm> terminateContracts =
      Action.create(MainFirm.class, SuperHomeCompany::terminateContract);

  public static Action<MainFirm> hireConsultants =
      Action.create(MainFirm.class, SuperHomeCompany::hireConsultants);

  public static Action<MainFirm> profitNloss =
      Action.create(
          MainFirm.class,
          a -> {
            a.getMessagesOfType(Messages.PNL.class).forEach(a::calculatePNLEachConsultant);
            a.netProfit();
          });
}
